=== debian/changelog ===
groonga (6.0.1-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build-depend on libzmq5-dev.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 31 Mar 2016 09:56:36 +0200

groonga (6.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control
    - Use Architecture: any to support more architectures.
    - Drop transitional groonga-server-http package.
  * debian/rules
    - Remove needless DEB_BUILD_HARDENING flag.
    - Disable static library.
  * debian/groonga-httpd.default
    - Set variables to enable fast phrase search feature.

 -- HAYASHI Kentaro <hayashi@clear-code.com>  Mon, 28 Mar 2016 21:59:57 +0900

groonga (6.0.0-1ubuntu2) xenial; urgency=medium

  * Merge with Debian; remaining changes:
    - Build on all architectures.
  * Build-depend on libzmq5-dev.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Mar 2016 18:20:21 +0100

groonga (6.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control
    - Fix "undefined reference to `GRN_ATOMIC_ADD_EX'" on mips,mipsel,m68k.
      Closes: #770243
    - Update standards-version to 3.9.7
    - Add SSL/TLS dependency which is required by groonga-httpd.
  * patches/*
    - Remove needless use-jquery-flot-0.8.3.patch because it is fixed
      in upstream.

 -- HAYASHI Kentaro <hayashi@clear-code.com>  Sun, 28 Feb 2016 12:34:17 +0900

groonga (5.1.2-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build on all architectures.
    - Use GCC atomic builtins, link with -latomic.
    - Also mark new binary package, groonga-token-filter-stem, to build for
      all architectures.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 11 Feb 2016 08:39:45 -0800

groonga (5.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * patches/use-jquery-flot-0.8.3.patch
    - Fix source-is-missing lintian error.
  * debian/rules,debian/control
    - Fix automake related FTBFS issue which is caused by added patch.

 -- HAYASHI Kentaro <hayashi@clear-code.com>  Sat, 30 Jan 2016 21:48:00 +0900

groonga (5.1.1-1ubuntu2) xenial; urgency=medium

  * Also mark new binary package, groonga-token-filter-stem, to build for
    all architectures.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Jan 2016 21:07:05 -0800

groonga (5.1.1-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build on all architectures.
    - Use GCC atomic builtins, link with -latomic.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Jan 2016 17:38:04 -0800

groonga (5.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/copyright
    - Fix I:unused-file-paragraph-in-dep5-copyright paragraph notifications.
  * debian/rules
    - Fix FTBFS on ppc64el due to outdated config.guess in vendor/onigmo-source.

 -- HAYASHI Kentaro <hayashi@clear-code.com>  Sat, 02 Jan 2016 20:47:09 +0900

groonga (5.1.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Import upstream debian/* changes.
    - Closes: #799167, #800451
  * Do not delete conffiles which are owned by other packages
    - Closes: #773029
  * debian/source.lintian-overrides
    - Suppress source-is-missing error.
  * debian/tests/*
    - Add files for autopkgtest.

 -- HAYASHI Kentaro <hayashi@clear-code.com>  Sun, 27 Dec 2015 00:00:00 +0900

groonga (4.0.6.1-2ubuntu3) xenial; urgency=medium

  * No-change rebuild against libmecab2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 03 Dec 2015 05:14:21 +0000

groonga (4.0.6.1-2ubuntu2) wily; urgency=medium

  * Use GCC atomic builtins, link with -latomic.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Oct 2015 10:31:17 +0200

groonga (4.0.6.1-2ubuntu1) wily; urgency=medium

  * Build on all architectures.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Oct 2015 09:57:30 +0200

groonga (4.0.6.1-2build1) wily; urgency=medium

  * No-change rebuild against libmecab2v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 12 Aug 2015 01:07:32 +0000
