=== debian/watch ===
version=3

http://packages.groonga.org/source/groonga/groonga-(.*).tar.gz debian uupdate
